'use strict'
// es6

// todo: look into using browser.storage.sync, for now, that api is unreleased
// todo: workaround bug in FF < 52.0, where browser.storage.get() would pass you back an array,
//       then I should be able lower the min version

function showWhitelist() {
    browser.storage.local.get().then(
        settings => {
            // todo: does line-ending style matter, e.g. if someone pastes this list into Notepad?
            document.forms[0].whitelist.value = (settings.whitelist || []).join('\r\n')
            document.forms[0].whitelist.removeAttribute('disabled')
        },
        error => { throw error })
}

function settingsLine(line) {
    // Either it's a domain, a comment or a blank line
    return domain(line) || (
        /^\s*$/.test(line) ? line :
        /^\s*#/.test(line) ? line :
        '# ' + line
    )}
// Most domain normalization tests are in shared.js:
check(settingsLine, 'example.com', 'example.com')
check(settingsLine, 'http://example.com', 'example.com')
check(settingsLine, 'localhost', 'localhost')
check(settingsLine, '', '')
check(settingsLine, '  ', '  ')
check(settingsLine, '# foo', '# foo')
check(settingsLine, ' # foo', ' # foo')

document.addEventListener('DOMContentLoaded', function () {
    document.forms[0].onsubmit = function () {
        const domains = this.whitelist.value
            .split(/\r?\n/)
            .map(settingsLine)
        browser.storage.local.set({
            whitelist: domains
        })
        return false
    }

    showWhitelist()
    onSettingsChange(showWhitelist)
})
